Laser Server
============
v3.0

Webcam server written in python using libdc1394. Written for use with the Simtable Point Grey firefly camera. Supports REST requests for shutter, gain, and trigger delay.

Usage
-----

<ul>
<li>
  Different formats based on extension. Supported extensions are jpg, png, and bmp.<br/>
  http://127.0.0.1:8080/shot.jpg
</li>
<li>
  Shutter and Gain can be set absolutely:<br/>
  http://127.0.0.1:8080/shot.jpg?shutter=4&gain=0
</li>
<li>
  The delay in seconds afer GPIO trigger signal:<br/>
  http://127.0.0.1:8080/shot.jpg?delay=0.002</li>
<li>
  Negative numbers turn on automatic mode:<br/>
  http://127.0.0.1:8080/shot.jpg?shutter=-1&gain=-1&delay=-1
</li>
<li>
  You don't need to take a picture to set the parameters:<br/>
  http://127.0.0.1:8080/?shutter=4&gain=0&delay=0.002
</li>
<li>
  Find the brightest Point:<br/>
  http://127.0.0.1:8080/brightestpoint.json
</li>
<li>
  Find the brightest Point:<br/>
  http://127.0.0.1:8080/brightestpoint.json?shutter=40&gain=0
</li>
<li>
Test page: http://127.0.0.1:8080/stressTest.html
</li>
<li>
Video page: http://127.0.0.1:8080/video.html
</li>
</ul>


Installation
------------

1. Install python3.8 
  [https://www.python.org/ftp/python/3.8.0/python-3.8.0-macosx10.9.pkg](https://www.python.org/ftp/python/3.8.0/python-3.8.0-macosx10.9.pkg)
3. `sh install_usb3.sh`

Starting the web server
-----------------------

    python3.8 server.py or sh start.sh
